package fstree

import (
	"time"

	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/shard/mode"
)

type Metrics interface {
	SetParentID(parentID string)

	SetMode(mode mode.ComponentMode)
	Close()

	Iterate(d time.Duration, success bool)
	Delete(d time.Duration, success bool)
	Exists(d time.Duration, success bool)
	Put(d time.Duration, size int, success bool)
	Get(d time.Duration, size int, success bool)
	GetRange(d time.Duration, size int, success bool)
	ObjectsCount(d time.Duration, success bool)
}

type noopMetrics struct{}

func (m *noopMetrics) SetParentID(string)                {}
func (m *noopMetrics) SetMode(mode.ComponentMode)        {}
func (m *noopMetrics) Close()                            {}
func (m *noopMetrics) Iterate(time.Duration, bool)       {}
func (m *noopMetrics) Delete(time.Duration, bool)        {}
func (m *noopMetrics) Exists(time.Duration, bool)        {}
func (m *noopMetrics) Put(time.Duration, int, bool)      {}
func (m *noopMetrics) Get(time.Duration, int, bool)      {}
func (m *noopMetrics) GetRange(time.Duration, int, bool) {}
func (m *noopMetrics) ObjectsCount(time.Duration, bool)  {}
