package deletesvc

import (
	"context"

	objectV2 "git.frostfs.info/TrueCloudLab/frostfs-api-go/v2/object"
	deletesvc "git.frostfs.info/TrueCloudLab/frostfs-node/pkg/services/object/delete"
)

// Service implements Delete operation of Object service v2.
type Service struct {
	svc *deletesvc.Service
}

// NewService constructs Service instance from provided options.
func NewService(svc *deletesvc.Service) *Service {
	return &Service{
		svc: svc,
	}
}

// Delete calls internal service.
func (s *Service) Delete(ctx context.Context, req *objectV2.DeleteRequest) (*objectV2.DeleteResponse, error) {
	resp := new(objectV2.DeleteResponse)

	body := new(objectV2.DeleteResponseBody)
	resp.SetBody(body)

	p, err := s.toPrm(req, body)
	if err != nil {
		return nil, err
	}

	err = s.svc.Delete(ctx, *p)
	if err != nil {
		return nil, err
	}

	return resp, nil
}
